# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%global short_name commons-configuration

%define section free

%define reltag .redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

%define maven_version 1.6-redhat-2

Name:           apache-commons-configuration
Version:        1.6
Release:        7.2%{?reltag}%{?dist}.5
Epoch:          0
Summary:        Apache Commons Configuration Package
Group:          Development/Java

%if %with mead
Source100: commons-configuration-commons-configuration-1.6-redhat-2-sources.zip
Source101: commons-configuration-commons-configuration-1.6-redhat-2-patches.zip
Source102: commons-configuration-1.6-redhat-2-javadoc.jar
Source103: commons-configuration-1.6-redhat-2.pom
Source104: commons-configuration-1.6-redhat-2-site.xml
Source105: commons-configuration-1.6-redhat-2-sources.jar
Source106: commons-configuration-1.6-redhat-2.jar
%endif

License:        ASL 2.0
URL:            http://commons.apache.org/configuration/

%if %without mead
Source0:        http://www.apache.org/dist/commons/configuration/source/commons-configuration-%{version}-src.tar.gz
Patch0:         apache-commons-configuration-pom.patch
Patch1:         apache-commons-configuration-build.patch
%endif

Obsoletes:      jakarta-commons-configuration < %{epoch}:%{namedversion}-%{release}
Provides:       jakarta-commons-configuration = %{epoch}:%{namedversion}-%{release}
%if 0
Obsoletes:      commons-configuration < %{epoch}:%{namedversion}-%{release}
%endif
Provides:       commons-configuration = %{epoch}:%{namedversion}-%{release}

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       commons-beanutils >= 0:1.8.0
# Require old package name to work around a bug in the GCJ Java package
# in RHEL-5 which has an unversioned provides for the short name
Requires:       jakarta-commons-collections >= 0:3.2.1
%if 0
# XXX: don't have, optional
Requires:       commons-digester >= 0:1.8
%endif
# Must use the legacy name so it can be installed on RHEL-6
# where commons-lang is not provided
Requires:       jakarta-commons-lang >= 0:2.4
#Requires:       slf4j >= 0:1.6.1
Requires:       slf4j

%if %without mead
#
# FIXME: don't have 1.2.2; needs apache build
BuildRequires:  jakarta-commons-dbcp >= 0:1.2.1
BuildRequires:  commons-pool >= 0:1.4
BuildRequires:  hsqldb >= 0:1.7.2.2
# FIXME: don't have
#BuildRequires:  dbunit >= 0:2.1
BuildRequires:  junit4 >= 0:3.8.1
# FIXME: don't have
#BuildRequires:  junit-addons >= 0:1.4
# FIXME: our build seems incomplete
BuildRequires:  mockobjects >= 0:0.09
#
BuildRequires:  java-devel
BuildRequires:  jpackage-utils

BuildRequires:  apache-commons-parent >= 0:22
BuildRequires:  jboss-parent
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-changes >= 0:2.0
BuildRequires:  maven-checkstyle-plugin >= 0:2.2
BuildRequires:  rat-maven-plugin
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  commons-beanutils >= 0:1.8.0
BuildRequires:  commons-codec >= 0:1.3
BuildRequires:  commons-collections >= 0:3.2.1
# FIXME: needs apache build
BuildRequires:  jakarta-commons-digester >= 0:1.8
BuildRequires:  commons-jxpath >= 0:1.3
BuildRequires:  commons-lang >= 0:2.4
BuildRequires:  slf4j >= 0:1.6.1
# XXX: 2.4
BuildRequires:  servlet_api
BuildRequires:  xalan-j2 >= 0:2.7.0
BuildRequires:  xerces-j2 >= 0:2.3.0
# XXX: 1.0.b2
BuildRequires:  xml-commons-jaxp-1.3-apis 
# XXX: 1.4
BuildRequires:  javamail_1_4_api
BuildRequires:  log4j >= 0:1.2.8
BuildRequires:  ant >= 0:1.6.5
# FIXME: brew bug
BuildRequires:  apache-commons-logging >= 0:1.1.1
%endif

#
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{namedversion}-%{release}-root

%description
Configuration is a project to provide a generic Configuration 
interface and allow the source of the values to vary. It 
provides easy typed access to single, as well as lists of 
configuration values based on a 'key'. 
Right now you can load properties from a simple properties 
file, a properties file in a jar, an XML file, JNDI settings, 
as well as use a mix different sources using a 
ConfigurationFactory and CompositeConfiguration. 
Custom configuration objects are very easy to create now 
by just subclassing AbstractConfiguration. This works 
similar to how AbstractList works.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

Obsoletes:      jakarta-commons-configuration-repolib < %{epoch}:%{namedversion}-%{release}
Provides:       jakarta-commons-configuration-repolib = %{epoch}:%{namedversion}-%{release}
%if 0
Obsoletes:      commons-configuration-repolib < %{epoch}:%{namedversion}-%{release}
%endif
Provides:       commons-configuration-repolib = %{epoch}:%{namedversion}-%{release}

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for commons-configuration
Group:          Development/Documentation

Obsoletes:      jakarta-commons-configuration-javadoc < %{epoch}:%{namedversion}-%{release}
Provides:       jakarta-commons-configuration-javadoc = %{epoch}:%{namedversion}-%{release}
%if 0
Obsoletes:      commons-configuration-javadoc < %{epoch}:%{namedversion}-%{release}
%endif
Provides:       commons-configuration-javadoc = %{epoch}:%{namedversion}-%{release}

%description javadoc
Javadoc for commons-configuration.

%prep
%if %without mead
%setup -q -n commons-configuration-%{version}-src
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%{__perl} -pi -e 's/\r$//g;' LICENSE.txt NOTICE.txt RELEASE-NOTES.txt
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=local::default::file://`pwd`/maven2-brew
# FIXME: have to skip tests due to missing dependencies in brew
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip deploy javadoc:aggregate

# FIXME: repolib hack for maven deploy bug
%{__mv} maven2-brew/commons-configuration/commons-configuration/1.4-redhat-2/* maven2-brew/commons-configuration/commons-configuration/%{namedversion}/ || :
%{__rm} -rf maven2-brew/commons-configuration/commons-configuration/1.4-redhat-2/
%endif

%install
%{__rm} -rf %{buildroot}

# jar
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/commons-configuration-%{namedversion}.jar %{buildroot}%{_javadir}/commons-configuration-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/commons-configuration-%{namedversion}.jar %{buildroot}%{_javadir}/commons-configuration-%{namedversion}.jar
%endif

%{__ln_s} commons-configuration-%{namedversion}.jar %{buildroot}%{_javadir}/commons-configuration.jar
%{__ln_s} commons-configuration-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-commons-configuration-%{namedversion}.jar
%{__ln_s} commons-configuration.jar %{buildroot}%{_javadir}/jakarta-commons-configuration.jar

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/commons-configuration-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/commons-configuration-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{short_name}-%{namedversion}-javadoc.jar -d $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-%{namedversion}/
%{__rm} -r $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-%{namedversion}/META-INF

%endif
%{__ln_s} commons-configuration-%{namedversion} %{buildroot}%{_javadocdir}/commons-configuration
%{__ln_s} commons-configuration-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-commons-configuration-%{namedversion}
%{__ln_s} commons-configuration %{buildroot}%{_javadocdir}/jakarta-commons-configuration

# pom
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-commons-configuration.pom
%else
%{__cp} -p %{_sourcedir}/%{short_name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%endif
# depmap
%add_to_maven_depmap commons-configuration commons-configuration %{namedversion} JPP commons-configuration
[ x"%{name}" = x"commons-configuration" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/commons-configuration

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE.txt NOTICE.txt RELEASE-NOTES.txt
%endif
%{_javadir}*/commons-configuration-%{namedversion}.jar
%{_javadir}*/commons-configuration.jar
%{_javadir}*/jakarta-commons-configuration-%{namedversion}.jar
%{_javadir}*/jakarta-commons-configuration.jar
%{_mavenpomdir}/JPP-commons-configuration.pom
%{_mavendepmapfragdir}/commons-configuration

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/commons-configuration-%{namedversion}
%{_javadocdir}/commons-configuration
%{_javadocdir}/jakarta-commons-configuration-%{namedversion}
%{_javadocdir}/jakarta-commons-configuration

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6-7.2.redhat_2.5
- Rebuild for MD5

* Fri Sep 07 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.6-6.2.redhat_2.5
- Fix dependency management to eap 6.0.1 boms

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6-6.2.redhat_2.4
- Rebuild unsigned

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6-6.2.redhat_2.3
- Rebuild unsigned

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6-6.2.redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6-6.2.redhat_1.1
- Rebuild using cache signing

* Wed Jul 11 2012 Yong Yang <yyang@redhat.com> 0:1.6-6.2.redhat_1
- First mead build

* Thu Jul 05 2012 Fernando Nasser <fnasser@redhat.com> 0:1.6-6.1.redhat_1
- Require old package name to work around a bug in the GCJ Java package
  in RHEL-5 which has an unversioned provides for the short name

* Fri Apr 20 2012 Fernando Nasser <fnasser@redhat.com> 0:1.6-6.redhat_1
- Use legacy name used by RHEL-6 for commons-lang
- Fix release tag

* Thu Apr 12 2012 Fernando Nasser <fnasser@redhat.com> 0:1.6-5
- Remove version specification for slf4j at run-time

* Tue Apr 10 2012 David Walluck <dwalluck@redhat.com> 0:1.6-4.2
- resolve JBPAPP-8654
- update commons-digester version and set optional=true in pom
- update commons-jxpath version in pom

* Tue Mar 27 2012 David Walluck <dwalluck@redhat.com> 0:1.6-4.1
- add NOTICE.txt
- add repolib

* Fri Oct 08 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.6-4
- Provide compat symlinks for jakarta-commons-configuration

* Thu Sep 23 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.6-3
- Drop Requires for apache-commons-parent

* Thu Sep 09 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.6-2
- OK move it to free

* Wed Nov 18 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.6-1
- 1.6
- rename to apache-commons-configuration
- build with maven2 by default

* Wed Mar 18 2009 Yong Yang <yyang@redhat.com> - 0:1.4-4
- rebuild with new maven2 2.0.8 built in bootstrap mode

* Thu Feb 05 2009 Yong Yang <yyang@redhat.com> - 0:1.4-3
- Fix release tag

* Wed Jan 14 2009 Yong Yang <yyang@redhat.com> - 0:1.4-2jpp
- Import from dbhole's maven 2.0.8 packages, initial building

* Mon Aug 13 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.4-1jpp
- Upgrade to 1.4
- Add pom file

* Thu May 03 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2-3jpp
- Patch one test

* Wed Mar 07 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2-2jpp
- Add gcj_support option
- Optionally build without maven

* Mon Feb 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2-1jpp
- Upgrade to 1.2

* Mon Feb 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.1-2jpp
- Rebuild for JPP-1.7 and maven-1.1

* Thu Sep 15 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.1-1jpp
- Upgrade to 1.1
- Omit findbugs and tasks reports: don't have these plugins yet
- Requires java 1.4.2 to build

* Mon Feb 21 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0.f-1jpp
- Upgrade to 1.0 final, letter in version can be bumped with 1.1
- Prepare for build with maven, but still build with ant

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0.d3-2jpp
- Rebuild with ant-1.6.2
- Upgrade to Ant 1.6.X
* Mon Jan 19 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0.d3-1jpp
- First JPackage release
